<template>
    <v-container fluid>


        <v-card max-width="1200" class="ma-auto">

            <v-alert v-if="err != ''" dense text type="error" max-width="800" class="mx-auto my-2 pa-2">
                {{err}}
            </v-alert>
            <v-alert v-if="ok != ''" dense text type="success" max-width="800" class="mx-auto my-2 pa-2">
                {{success}}
            </v-alert>

            <div class="text-h4 text-lg-h3 pa-7"> SubContractors</div>

            <v-list two-line subheader>
                <v-list-item v-for="(s, i) in subcons" :key="s.id">
                    <v-container>
                        <v-row>
                            <v-list-item-avatar>
                                <v-img :src="s.logo"></v-img>
                            </v-list-item-avatar>
                            <v-list-item-content>
                                <v-list-item-title>
                                    {{s.name}}
                                    <v-icon :color="s.color" x-small>$vuetify.icons.circle</v-icon>

                                </v-list-item-title>
                                <v-list-item-subtitle v-text="s.id"></v-list-item-subtitle>
                            </v-list-item-content>
                            <v-list-item-action>
                                <v-btn icon :to="`/sub/${s.id}`">
                                    <v-icon color="grey lighten-1">mdi-information</v-icon>
                                </v-btn>
                            </v-list-item-action>
                            <v-list-item-action>
                                <v-tooltip bottom>
                                    <template v-slot:activator="{ on, attrs }">
                                        <v-btn @click="Toggle(i)" icon v-bind="attrs" v-on="on">
                                            <v-icon color="grey lighten-1">
                                                {{ show[i] ? 'mdi-chevron-up' :'mdi-chevron-down' }}
                                            </v-icon>
                                        </v-btn>
                                    </template>
                                    <span>Show/Hide Workers</span>
                                </v-tooltip>
                            </v-list-item-action>
                        </v-row>
                        <v-expand-transition>
                            <v-row v-if="show[i]">
                                <Workers :sub="s.id"/>
                            </v-row>
                        </v-expand-transition>
                    </v-container>

                </v-list-item>
            </v-list>
            <v-tooltip bottom>
                <template #activator="{ on, attrs }">
                    <v-btn color="pink" dark absolute bottom right fab v-bind="attrs" v-on="on" to="/sub/create">
                        <v-icon>mdi-plus</v-icon>
                    </v-btn>
                </template>
                <span>Create SubContractor</span>
            </v-tooltip>
        </v-card>

    </v-container>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
    import {Component, Vue} from 'vue-property-decorator';
    import {Validable} from "../../mixins/Validable";
    import {Mixins} from "vue-mixin-decorator";
    import {SubContractorLightResponse} from "../../../../classLibrary/core/subContractorLightResponse";
    import {coreApi} from "../../init";
    import Workers from "../../components/Workers.vue";

    @Component({
        components: {Workers}
    })
    export default class AllSubCon extends Mixins<Validable>(Validable) {

        subcons: SubContractorLightResponse[] = [];
        show: boolean[] = [];

        async update() {
            const fr = await coreApi.Get<SubContractorLightResponse[]>("SubContractor");
            if (fr.success) {
                this.subcons = fr.Ok!;
                const diff = this.subcons.length - this.show.length;
                for (let i = 0; i < diff; i++) {
                    this.show.push(false);
                }
            } else {
                this.err = fr.error!;
            }
        }

        async created() {
            await this.update();
        }

        Toggle(i: number) {
            Vue.set(this.show, i, !this.show[i]);
        }

    }
</script>
